# <PRE>
# Copyright for the Uniform Repository Service (c) 1995 - 2015, 2022,
# by Gerald Banon. All rights reserved.
# Version 2.1
# script.tcl

# Archive service for IBI resolution
# urlib.net/www/2014/03.16.03.40

if 0 {
# examples of use
# communication scheme step 3
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=inclusionConfirmationRequest
#	http://gjfb:1905/83LX3pFwXQZeBBx/fJ3Bm?servicesubject=inclusionConfirmationRequest - not implemented and not needed

# communication scheme step 3
	http://gjfb:1905/urlib.net/www/2014/03.16.03.40?servicesubject=urlRequest&parsedibiurl.ibi=3ERPFQRT3W/39AFDTP
	http://gjfb:1905/col/urlib.net/www/2014/03.16.03.40/doc/script.cgi?parsedibiurl.ibi=3ERPFQRT3W/39AFDTP&servicesubject=urlRequest
# recommended use (norm):
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=urlRequest&parsedibiurl.ibi=3ERPFQRT3W/39AFDTP
	http://gjfb:1905/rep-/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=urlRequest&parsedibiurl.ibi=3ERPFQRT3W/39AFDTP
	http://gjfb:1905/rep/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=urlRequest&parsedibiurl.ibi=3ERPFQRT3W/39AFDTP
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=siteStampinclusionConfirmationRequest
# => {gjfb:1905 800} dpi.inpe.br/banon/1999/01.09.22.14 192.168.1.31 USP 2015:01.02.16.50.37 gerald.banon@gmail.com
	http://gjfb:1905/rep-/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=siteStampinclusionConfirmationRequest
# => {gjfb:1905 800} dpi.inpe.br/banon/1999/01.09.22.14 192.168.1.31 USP 2015:01.02.16.50.37 gerald.banon@gmail.com
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14
	http://gjfb:1905/rep-/dpi.inpe.br/banon/1999/01.09.22.14
	http://gjfb:1905/rep/dpi.inpe.br/banon/1999/01.09.22.14
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?xxx=4
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=4

# communication scheme step 5
	http://gjfb:1905/dpi.inpe.br/banon/1999/01.09.22.14?servicesubject=acknowledgment&contenttype=Data&ibi=rep+iconet.com.br/banon/2001/02.10.22.55+ibip+LK47B6W/E6H5HH&site=gjfb
}

proc Script {} {
if [catch {
	global env
	global serverAddress	;# used by AcknowledgeArchive
	global homePath	;# used only in GetSessionList called by CheckSession called by AcknowledgeArchive
	global URLibServiceRepository	;# used only in GetSessionList called by CheckSession called by AcknowledgeArchive

# localSite
	set localSite $env(SERVER_NAME):$env(SERVER_PORT)
# serverAddress
	set serverAddress [list $env(SERVER_NAME) $env(URLIB_PORT)]
# loCoInRep
	set loCoInRep $env(LOCOINREP)
# homePath (used in GetSessionList only)
	set homePath $env(DOCUMENT_ROOT)
# URLibServiceRepository (used also by GetSessionList)
	set URLibServiceRepository $env(URLIB_SERVICE_REP)
# col
	set col ../../../../..
	source ../$col/$URLibServiceRepository/doc/cgi/mirrorfind-.tcl	;# MultipleExecute
	source ../$col/$URLibServiceRepository/doc/utilities1.tcl	;# ReturnTimeOutReference (called by MultipleSubmit in cgi/mirrorfind-.tcl)

# cgi
	if [info exists env(QUERY_STRING)] {
# set xxx --$env(QUERY_STRING)--
# Store xxx C:/tmp/bbb.txt auto 0 a
		foreach {name value} [split $env(QUERY_STRING) &=] {
			set cgi([DecodeURL $name]) [DecodeURL $value]
		}
	}

# serverAddress
	set serverAddress [list $env(SERVER_NAME) $env(URLIB_PORT)]

	ConditionalSet serviceSubject cgi(servicesubject) {}

	switch $serviceSubject {
		urlRequest {
			puts {Content-Type: text/plain}
			puts {}

# criterionList
# created in ResolveIBI
			set criterionList {}
			foreach fieldName [array names cgi -regexp {clientinformation|parsedibiurl}] {
#				regsub -all { } $cgi($fieldName) {+} fieldValue
				set fieldValue $cgi($fieldName)
				lappend criterionList $fieldName $fieldValue
			}

# MULTIPLE SUBMIT
			set command [list list GetURLPropertyList $criterionList]
# puts $command\n
			set siteList [list $serverAddress]
			set searchResultList [MultipleExecute $siteList $command]	;# scenario 0 - level 1 is for MultipleSubmit be able to reach currentRep
# set xxx --$searchResultList--
# Store xxx C:/tmp/bbb.txt auto 0 a
# Edit searchResultList
			set resultList {}
			foreach {name value} [join $searchResultList] {
				lappend resultList [list $name $value]
			}
			set maximumSpaceLength 0
			foreach pair $resultList {
				foreach {name value} $pair {break}
				set maximumSpaceLength [Max $maximumSpaceLength [expr 1 + [string length $name]]]
			}
			set resultList2 {}
			foreach pair [lsort -index 0 $resultList] {
				foreach {name value} $pair {break}
				set spaceLength [expr $maximumSpaceLength - [string length $name]]
#				lappend resultList2 "\t$name [string repeat { } $spaceLength] [list $value]"
				lappend resultList2 "$name [string repeat { } $spaceLength] [list $value]"
			}
# norm simplification
if 0 {
			set searchResultList "{\n[join $resultList2 \n]\n}"
} else {
			set searchResultList [join $resultList2 \n]
}
# set xxx [fconfigure stdout -encoding]	;# gjfb returns cp1252
# Store xxx C:/tmp/bbb.txt auto 0 a
# set xxx --$searchResultList--
# Store xxx C:/tmp/bbb.txt auto 0 a
# Edit searchResultList - end
#			puts $searchResultList	;# utf-8 encoded in GetURLPropertyList
			puts $searchResultList
#			puts [encoding convertto utf-8 $searchResultList]	;# commented by GJFB in 2015-01-07 - introduces accent problem (O -> ?O) probably already utf-8, new conversion is inappropriate
			return	;# continues in FindURLPropertyList
		}
		inclusionConfirmationRequest {
# communication scheme step 3
			puts {Content-Type: text/plain}
			puts {}

# communication scheme step 3
			set command [list list ReturnConfirmation]
# MULTIPLE SUBMIT
			set confirmation [MultipleExecute [list $serverAddress] $command]
			puts $confirmation
#			puts [encoding convertto utf-8 $confirmation]
			return
		}
		acknowledgment {
			puts {Content-Type: text/plain}
			puts {}
			set urlPropertyList {}
			foreach fieldName [array names cgi] {
				set fieldValue $cgi($fieldName)
				if ![string equal {servicesubject} $fieldName] {
					lappend urlPropertyList $fieldName $fieldValue
				}
			}
# set xxx --$urlPropertyList--
# Store xxx C:/tmp/bbb.txt auto 0 a
# puts $urlPropertyList\n
			AcknowledgeArchive $urlPropertyList	;# PostponeOneClickCount
			puts {notice {acknowledgment received}}	;# acknowledgment receipt (aviso de recepo) - could be any thing
			return
		}
		default {
#			puts "Location: http://$localSite/col/$loCoInRep/doc/@index.html"	;# All in one page
			puts "Location: http://$localSite/col/$loCoInRep/doc/@index.html"	;# All in one page
#			puts "Location: http://$localSite/rep-/$loCoInRep/index1.html"	;# Page by page
			puts ""
			return
		}
	}

} m] {puts $m; if 0 {global errorInfo; puts $errorInfo}}
}

# Script - end
# ----------------------------------------------------------------------
# </PRE>
